module.exports = (...args) => {
  if (args.length === 0) {
    return "";
  }

  const head = args[0];
  const tail = args.slice(1);
  const ret = typeof head === "string" ? replacer(head, tail) : stringify(head);

  return tail.length === 0
    ? ret
    : ret + " " + tail.map(x => stringify(x)).join(" ");
};

const stringify = x => (typeof x === "object" ? JSON.stringify(x) : String(x));

const replacer = (str = "", args = []) =>
  str.replace(/%[sfidOoj]/g, T => (!args[0] ? T : convert(args.shift(), T)));

const convert = (x, T) =>
  isInteger(T)
    ? parseInt(x, 10).toString()
    : isFloat(T)
      ? Number(x).toString()
      : isObject(T) ? JSON.stringify(x) : String(x);

const isInteger = T => T === "%i";
const isFloat = T => T === "%f" || T === "%d";
const isObject = T => T === "%O" || T === "%o" || T === "%j";
